<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<div *ngIf="initilizing$ | async; else initialized">
  <div class="size-96 flex items-center justify-center">
    <app-spinner [size]="24"></app-spinner>
  </div>
</div>
<ng-template #initialized>
  <div *ngIf="errorLoading$ | async; else noError"></div>
  <ng-template #noError>
    <ng-container *ngLet="organisation$ | async as org">
      <ng-container *ngLet="loading$ | async as loading">
        <app-role-checker [allowedRoles]="[admin]">
          <ng-template let-authorized>
            <div class="pb-4 text-text-500 w-96 mt-8">
              <ng-container *ngIf="org?.isPartner">You have an active partnership with the following organisation:</ng-container>
              <ng-container *ngIf="!org?.isPartner">
                <ng-container *ngIf="org?.isPendingPartner">
                  <ng-container *ngIf="org?.isIngressPendingPartner">The following organisation is looking to partner with you:</ng-container>
                  <ng-container *ngIf="!org?.isIngressPendingPartner">You have send a partnership request to the following organisation:</ng-container>
                </ng-container>
                <ng-container *ngIf="!org?.isPendingPartner">The following organisation has no partnership with your organisation:</ng-container>
              </ng-container>
            </div>
            <div class="card">
              <div class="flex gap-4 py-5">
                <div class="size-24 rounded-full bg-white flex items-center justify-center leading-none">
                  <div *ngIf="org?.avatar"></div>
                  <div *ngIf="!org?.avatar">
                    <i class="fa fa-user-group opacity-40" style="font-size: 2rem"></i>
                  </div>
                </div>
                <div class="flex flex-col gap-10">
                  <div class="flex flex-col">
                    <div class="text-xl font-semibold">{{ org?.name }}</div>
                    <div class="flex items-center gap-1">
                      <i class="pi pi-map-marker" style="font-size: 0.85rem"></i>
                      <div>{{ org?.location }}, {{ org?.countryCode }}</div>
                    </div>
                    <div *ngIf="org?.businessId" class="flex items-center gap-1">
                      <div>Business Id:</div>
                      <div>{{ org?.businessId }}</div>
                    </div>
                  </div>
                  <div class="flex flex-col gap-1">
                    <div class="w-56 bg-grey opacity-40 rounded-full h-4"></div>
                    <div class="w-96 bg-grey opacity-40 rounded-full h-4"></div>
                  </div>
                </div>
              </div>
            </div>
            <div class="mt-12 text-text-500 font-semibold text-base">
              <ng-container *ngIf="org?.isPartner">Do you want to remove the partnership?</ng-container>
              <ng-container *ngIf="!org?.isPartner">
                <ng-container *ngIf="org?.isPendingPartner">
                  <ng-container *ngIf="org?.isIngressPendingPartner">Do you want to accept a partnership request?</ng-container>
                  <ng-container *ngIf="!org?.isIngressPendingPartner">Do you want to cancel the partnership request?</ng-container>
                </ng-container>
                <ng-container *ngIf="!org?.isPendingPartner">Do you want to send a partnership request?</ng-container>
              </ng-container>
            </div>
            <div class="mt-4 text-text-500 font-semibold pb-12">
              <ng-container *ngIf="org?.isPartner">
                <div class="flex flex-col gap-4 items-start">
                  <p-button
                    [loading]="loading"
                    label="Remove"
                    icon="fa fa-trash-can"
                    [outlined]="true"
                    severity="danger"
                    (onClick)="cancelPartnership()"
                    [disabled]="!authorized"
                  ></p-button>
                  <app-info *ngIf="!authorized" message="Insufficient role to remove the partnership"></app-info>
                </div>
              </ng-container>
              <ng-container *ngIf="!org?.isPartner">
                <ng-container *ngIf="org?.isPendingPartner">
                  <ng-container *ngIf="org?.isIngressPendingPartner">
                    <div class="flex flex-col gap-4 items-start">
                      <div class="flex items-center gap-4">
                        <p-button [loading]="loading" label="Accept" icon="pi pi-check" severity="primary" (onClick)="acceptPartnership()" [disabled]="!authorized"></p-button>
                        <p-button
                          [loading]="loading"
                          label="Decline"
                          icon="pi pi-times"
                          [outlined]="true"
                          severity="danger"
                          (onClick)="cancelPartnership()"
                          [disabled]="!authorized"
                        ></p-button>
                      </div>
                      <app-info *ngIf="!authorized" message="Insufficient role to accept/decline the partnership request"></app-info>
                    </div>
                  </ng-container>
                  <ng-container *ngIf="!org?.isIngressPendingPartner">
                    <div class="flex items-center gap-4">
                      <p-button
                        [loading]="loading"
                        label="Cancel"
                        icon="pi pi-times"
                        [outlined]="true"
                        severity="danger"
                        (onClick)="cancelPartnership()"
                        [disabled]="!authorized"
                      ></p-button>
                      <app-info *ngIf="!authorized" message="Insufficient role to cancel the partnership request"></app-info>
                    </div>
                  </ng-container>
                </ng-container>
                <ng-container *ngIf="!org?.isPendingPartner">
                  <div class="flex items-center gap-4">
                    <p-button [loading]="loading" label="Send" icon="fa fa-handshake-simple" severity="primary" (onClick)="createPartnership()" [disabled]="!authorized"></p-button>
                    <app-info *ngIf="!authorized" message="Insufficient role to send the partnership request"></app-info>
                  </div>
                </ng-container>
              </ng-container>
            </div>
          </ng-template>
        </app-role-checker>
      </ng-container>
    </ng-container>
  </ng-template>
</ng-template>
